#ifndef STEP_H
#define STEP_H

void one_step(struct qlist *lptr, struct tape *tptr, int nstep,
                                                 int debug, int *status);
/*
      Execute one step of the turing program.
          struct qlist *lptr  --  pointer to the quintuple list
           struct tape *tptr  --  pointer to the tape 
                   int nstep  --  which number step the current one is
                   int debug  --  display more info if trace is on
*/

void step(struct qlist *lptr, struct tape *tptr, int *status);
/*
      Executes the tm 'step' command.  The number of steps to take
      is extracted from the command queue in this routine.
*/

void go(struct qlist *lptr, struct tape *tptr, int *status);
/*
      Executes the tm 'go' command.  Keeps making steps until the machine
      reaches halt sate, or until MAX_STEP number of steps have been
      taken.  If MAX_STEP number o steps have been take, this routine
      asks if more should be taken.
*/

void move(struct tape *tptr, int *status);
/*
       Moves the tape head position according to the command of the
       user.
*/

#endif  
