/* WATCH.H

   header file for WATCH facility:  the setting of break points and
   watched variables. 
*/

void set_watch();
/*
      set watch on a machine state or a tape symbol.  This is an interactive
      routine.
*/

void cancel_watch();
/*
      cancel a watch on a machine state or a tape symbol.
*/

void set_break(struct qlist *qlst, int *status);
/*
      set a break point on a quintuple.
*/

void cancel_break(struct qlist *qlst, int *status);
/*
      cancel a break point
*/

void show_watch();
/*
      show the watch variables.
*/

void show_break(struct qlist *qlst, int *status);
/*
      show the break points.
*/


void cancel(struct qlist *lptr);
/*
      Cancel a watch point or a break point.  User is prompted to
      say which.
*/
